const { DataTypes } = require("sequelize");

module.exports = (sequelize) => {
	const MaritalStatus = sequelize.define(
		"maritalstatuse",
		{
			id: {
				type: DataTypes.INTEGER,
				autoIncrement: true,
				primaryKey: true,
			},
			creation: { type: DataTypes.DATE, allowNull: false },
			modified: { type: DataTypes.DATE, allowNull: false },
			modified_by: { type: DataTypes.INTEGER, allowNull: false },
			owner: { type: DataTypes.INTEGER, allowNull: false },
			enabled: { type: DataTypes.BOOLEAN, allowNull: false },

			// main
			name: { type: DataTypes.STRING(50), allowNull: false },
			display_name: { type: DataTypes.STRING(50), allowNull: false },

			// fk
			company_id: { type: DataTypes.INTEGER, allowNull: true },
		},
		{
			tableName: "maritalstatuses",
			freezeTableName: true,
		}
	);

	/**
	 * Associates the MaritalStatus model with other models.
	 * @param {object} models - The models to associate with.
	 * @description
	 */
	MaritalStatus.associate = (models) => {
		MaritalStatus.belongsTo(models.Company, { foreignKey: "company_id", as: "company" });
		MaritalStatus.hasMany(models.Patient, { foreignKey: "maritalstatus_id", as: "patients" });
	};

	return MaritalStatus;
};
